package milab.lab03.Environment.MusicVolumeAgent;

import jade.core.AID;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class MusicVolumeAgentGui extends JFrame {
	
	private MusicVolumeAgent myAgent;

	private JTextField valueField;
	//private ButtonGroup group;
	public JRadioButton button1;
	private String button1String = "silent";
	public JRadioButton button2;
	private String button2String = "soft";
	public JRadioButton button3;
	private String button3String = "normal";
	public JRadioButton button4;
	private String button4String = "loud";

	MusicVolumeAgentGui(MusicVolumeAgent a) {
		
		super(a.getLocalName());
		
		myAgent = a;

		JPanel p = new JPanel();
		p.setLayout(new GridLayout(1, 1));
		valueField = new JTextField(15);
		valueField.setText(myAgent.getMusicVolume());
		valueField.disable();
		p.add(valueField);
		getContentPane().add(p, BorderLayout.NORTH);
		
		p = new JPanel();
		p.setLayout(new GridLayout(3, 1));
		
	    //Create the radio buttons.
	    JRadioButton button1 = new JRadioButton(button1String);
	    button1.setMnemonic(KeyEvent.VK_S);
	    button1.setActionCommand(button1String);

	    JRadioButton button2 = new JRadioButton(button2String);
	    button2.setMnemonic(KeyEvent.VK_F);
	    button2.setActionCommand(button2String);

	    JRadioButton button3 = new JRadioButton(button3String);
	    button3.setMnemonic(KeyEvent.VK_N);
	    button3.setActionCommand(button3String);

	    JRadioButton button4 = new JRadioButton(button4String);
	    button3.setMnemonic(KeyEvent.VK_L);
	    button3.setActionCommand(button4String);	    
	    
		String musicVolume = myAgent.getMusicVolume();

		if (musicVolume.equals("silent")) {

			button1.setSelected(true);

		} else if (musicVolume.equals("soft")) {
			  
			button2.setSelected(true);
			  
		} else if (musicVolume.equals("normal")) {
			  
			button3.setSelected(true);
			  
		} else { // == "loud"
			  
			button4.setSelected(true);
			  
		}	    
	    
	    //Group the radio buttons.
	    ButtonGroup group = new ButtonGroup();
	    group.add(button1);
	    group.add(button2);
	    group.add(button3);
	    group.add(button4);
	    
	    //Register a listener for the radio buttons.
	    button1.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent ev) {
				
				try {
					
					valueField.setText(button1String);
					myAgent.updateMusicVolume(button1String);
					
				} catch (Exception e) {
					
					JOptionPane.showMessageDialog(MusicVolumeAgentGui.this, "Invalid values. " + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE); 
					
				}
				
			}
			
		});
	    button2.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent ev) {
				
				try {
					
					valueField.setText(button2String);
					myAgent.updateMusicVolume(button2String);
					
				} catch (Exception e) {
					
					JOptionPane.showMessageDialog(MusicVolumeAgentGui.this, "Invalid values. " + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE); 
					
				}
				
			}
			
		});
	    button3.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent ev) {
				
				try {
					
					valueField.setText(button3String);
					myAgent.updateMusicVolume(button3String);
					
				} catch (Exception e) {
					
					JOptionPane.showMessageDialog(MusicVolumeAgentGui.this, "Invalid values. " + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE); 
					
				}
				
			}
			
		});
	    button4.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent ev) {
				
				try {
					
					valueField.setText(button4String);
					myAgent.updateMusicVolume(button4String);
					
				} catch (Exception e) {
					
					JOptionPane.showMessageDialog(MusicVolumeAgentGui.this, "Invalid values. " + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE); 
					
				}
				
			}
			
		});
	    
	    p.add(button1);
	    p.add(button2);
	    p.add(button3);
	    p.add(button4);
	    
	    getContentPane().add(p, BorderLayout.CENTER);    
	    
		// Make the agent terminate when the user closes 
		// the GUI using the button on the upper right corner	
		addWindowListener(new	WindowAdapter() {
			
			public void windowClosing(WindowEvent e) {
				
				myAgent.doDelete();
				
			}
			
		});
		
		setResizable(false);
		
	}
	
	public void show() {
		
		pack();
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		int centerX = (int)screenSize.getWidth() / 2;
		int centerY = (int)screenSize.getHeight() / 2;
		setLocation(centerX - getWidth() / 2, centerY - getHeight() / 2);
		super.show();
		
	}

	protected void setValueFieldText(String value) {
		
		valueField.setText(value);
		
	}
	
}
